import jsPlumb from 'jsplumb'
exports.Vjsplumb=function(){
    //只能连接一条情况
(function($) {
    this.dragApp=function(){
        var that=this;
        var mark=0;//使拖动的表id不重复
        // var json="";//保存ajax返回数据
        var connectArr;//保存拖拽的图形的关联数组
        var connections;//所有连接
        var jsons={"tables":[],"joins":[]}; 
        var addOptions={};
        var container="sdf"
        var targetPoint='';//目标端点id
        var sourcePoint='';//起点端点id
        var connectMode="inner";
        var inst;//jp实例对象
        var connectEvent;
         /**
         * 初始化表列表
         * @param eleId 绘制区域对象id
         * @param data 后台返回数据d
         */
        /**
         * 初始化jsPlumb绘制
         * @param container 绘制区域jquery对象
         * @param fn 回调函数
         */
        this.init = function(fn,fn1,fn2){
            connectEvent=fn1;
            var that=this;
            jsPlumb.ready(function(){
                inst = jsPlumb.getInstance();
                
                inst.importDefaults(that.JP_defaultParam);
                fn();

                /** *绑定链接事件     **/
                inst.bind("connection",fn1);

                  //取消链接后触发
                inst.bind("connectionDetached", fn2);

                // 双击取消连接
                inst.bind("dblclick", function(conn, originalEvent) {
                    // inst.detach(conn);
                });
            });
        };

        this.obj=function(){
            return inst;
        }
        /**
         * 添加连接
         * @param srcid 源元素id
         * @param targetid 目标元素id
         * @param strokeStyle 线颜色
         */
        this.addConnect = function(options, overlays){
            var that=this;
            if (typeof(overlays) == "undefined") {
                overlays={}
            }
            var param = $.extend(true, {}, that.JP_defaultParam, options,overlays);
            var conn = inst.connect(param);
            return conn;
        };

        /**
         * 绘制端
         * @param id 需添加端点元素的id string
         * @param options 端点特有样式对象   object
         */
         this.addPoint=function(id,options){
            var point=inst.addEndpoint(id,options,mappedConnect);
            return point;
         }

         /**
         * 删除元素
         * @param id
         */
        this.removeElement = function(id){
            inst.select({source: id}).detach();
            inst.select({target: id}).detach();
            inst.remove(id);
        };
          /**
         * 获得所有连接
         */
        this.getConnects = function(){
           var connects =  inst.getConnections();
           return connects;
        };

         /**
         * 清空绘图区域
         @param container 绘图区域id
         */
        this.empty = function(container){
           inst.empty(container)
        };
         /**
         * 删除连线
         @param
         */
        this.removeConnects = function(ele){
           inst.detachAllConnections(ele)
           // inst.remove(ele)
        };
         /**
         * 删除端点
         @param ele 要删除指定端点的元素
         */
         this.deleteEndpoint=function(ele){
            inst.removeAllEndpoints(ele)
         }
         /**
         * 删除所有连线
         */
        this.detachConnects = function(){
           inst.detachEveryConnection()
        };
         /**
         * 删除某个连线
         */
        this.detach = function(conn){
           inst.detach(conn)
        };
        /**
         * 重绘一切
         * 
         */
        this.repaintElement = function(id){
            inst.repaintEverything(id)
            // inst.repaint(id)
        };
        /**
         * 解除绑定事件
         * 
         */
        this.unbind=function(event){
            // inst.unbind(event);
            inst.bind("connection",function(conn){
                inst.detach(conn)
            });
        };
        this.unbindDbl=function(){
            inst.unbind('dblclick')
        }
        /**
         * 绑定事件
         * 
         */
        this.bind=function(){
            /** *绑定链接事件     **/
            console.log(connectEvent)
            inst.unbind('connection');
            inst.bind("connection",connectEvent);
        };
        /**
         * 设置端点不能拖拽
         * params id:array
         */
         this.makeSource=function(id,p){
            inst.makeSource(id,p)
        }
         this.makeTarget=function(id,p){
            inst.makeTarget(id,p)
        }
         this.unmakeTarget=function(id){
            inst.unmakeTarget(id)
        }
        this.unmakeSource =function(id){
            inst.unmakeSource (id)
        }
         /**
         * 设置端点能拖拽
         * params id:array
         */
         this.Draggable=function(id){
            inst.setDraggable(id,true)
         }
         /************************* 默认参数和样式 *************************/
        /************************* 默认参数和样式 *************************/
     


        /************************* 默认参数和样式 *************************/
        /************************* 默认参数和样式 *************************/
        /**
         * jsPlumb默认参数
         */ 
        //基本连接线样式
        var connectorPaintStyle = {
          strokeStyle: "black",
          fillStyle: "transparent",
          radius: 5,
          lineWidth: 3
        };
        // 鼠标悬浮在连接线上的样式
        var connectorHoverStyle = {
          lineWidth: 3,
          strokeStyle: "black",
          outlineWidth: 2,
          outlineColor: "white",
        };
        //端点悬浮样式
        var endpointHoverStyle = {
          // fillStyle: "#7ac5cd",
          // strokeStyle: "#7ac5cd",

        };
        var arrowOverlay=[
            ["PlainArrow", { width: 10, length: 10, location: 1 }]
        ];
        var connectorOverlays=[//覆盖物
            ['Label',//文字
                {
                    location:0.5,//位置
                    cssClass:{font:'arial',fillStyle:'#ddd',padding:'10px'},//没起作用
                    visible:true,
                    label:"编辑",//
                    id:'label',
                    cssClass:"myclass",
                    events:{//覆盖物绑定的事件
                        click:function(labelOverlay, originalEvent){
                            
                            var connects=jsPlumb.getConnections();
                            labelClick(connects);
                            
                        }
                    }
                }
            ],
            ["PlainArrow", { width: 10, length: 10, location: 1 }]
        ]
        //实心圆端点样式设置
        this.JP_defaultParam = {
            // DragOptions: { cursor: 'pointer', zIndex: 2000 },
            endpoint: "Rectangle", //端点的形状
            connectorStyle: connectorPaintStyle,//连接线的颜色，大小样式
            connectorHoverStyle: connectorHoverStyle,
            endpointHoverStyle:endpointHoverStyle,
            paintStyle: {
                strokeStyle: "black",
                fillStyle: "transparent",
                width:0.1,
                height:0.1,
                lineWidth:2
            },    //端点的颜色样式,半径
            connector: ["Straight", { stub: [0, 0], gap:1 , cornerRadius: 5, alwaysRespectStubs: true },connectorPaintStyle],           
            isSource: true,  //是否可以拖动（作为连线起点）
            isTarget: true,  //是否可以放置（连线终点）
            maxConnections: -1,  // 设置连接点最多可以连接几条线
            // ConnectionsDetachable : true,
            ReattachConnections : true,
            // dragOptions:{scope:"ds1_db1_t1_c1-0"}
            // [["Arrow", { width: 40, length: 10, location: 0.5 }]]//覆盖物的样式
        };
        var mappedConnect = {
            // DragOptions: { cursor: 'pointer', zIndex: 2000 },
            endpoint: ["Rectangle",{cssClass:'pianyi'}], //端点的形状
            connectorStyle: connectorPaintStyle,//连接线的颜色，大小样式
            connectorHoverStyle: connectorHoverStyle,
            endpointHoverStyle:endpointHoverStyle,
              paintStyle: {
                strokeStyle: "transparent",
                fillStyle: "transparent",
                width:158,
                height:15,
                lineWidth: 2
              },    //端点的颜色样式,半径
            //anchor: "AutoDefault",
            // isSource: true,  //是否可以拖动（作为连线起点）
            connector: ["Straight", { stub: [0, 0], gap:3 }], //连接线的样式种类有[Bezier],[Flowchart],[StateMachine ],[Straight ],gap表示链接线两端与endpoint的距离，stub也是设置线与端点的距离吗 
            // isTarget: true,  //是否可以放置（连线终点）
            maxConnections: 1,  // 设置连接点最多可以连接几条线
            // [["Arrow", { width: 40, length: 10, location: 0.5 }]]//覆盖物的样式
        };
    
    };
})(jQuery)


}